<?php
error_reporting(E_ERROR);
ini_set("display_errors", 1);

include('config.php');



// ----------- Internet ellenőrzése --------------
$isInternet = fsockopen(_SERVER_DOMAIN, 80, $errno, $errstr, 30);

// ---------- Template könyvtár létehozása a telepítésekhez -------------
if (! file_exists(_SYSTEM_INSTALL_TMPL_DIR)) {
    mkdir(_SYSTEM_INSTALL_TMPL_DIR, 0777, true);
}



// ---------- A rendszerhez szükséges File system ellenőrzése -----------------
if (! file_exists(_BASE_DIR)) { $installFiles = true; }

// ---------- A rendszerhez szükséges SQL Adatbázis ellenőrzése -----------------
$mysqliSql = new mysqli(DB_HOST, DB_USER, DB_PASSWORD);
if ($mysqliSql->connect_error) {  $error_msg = "Nem lehet kapcsolódni az localhots MySQL rendszeréhez!<br> MySQL error: " . $mysqliSql->connect_error ; }
else {
    // --------- System SQL ellenőrzés -------------
    $mysqli = new mysqli(DB_HOST, DB_USER, DB_PASSWORD, DB_NAME);
    if ($mysqli->connect_error) {
        if ($mysqliSql->query("CREATE DATABASE ".DB_NAME)) {
            $mysqli = new mysqli(DB_HOST, DB_USER, DB_PASSWORD, DB_NAME);
            if ($mysqli->connect_error) {
                $error_msg = "Nem lehet kapcsolódni a <b>".DB_NAME."</b> adatbázishoz!<br> MySQL error: " . $mysqli->connect_error ;
            } else {
                $installSql = true;
            }
        } else { $error_msg = "Nem lehet létrehozni a <b>".DB_NAME."</b> adatbázist!<br> MySQL error: " . $mysqli->connect_error ; }
    }

    else {
        $res = $mysqli->query("SHOW TABLES LIKE '" . DB_TABLE . "'");
        if (! ($res->num_rows > 0) ) {
            $installSql = true;
        }
    }

    // ------------ LimeSurvey SQL ellenőrzés ------------------
    $mysqliLS = new mysqli(DB_HOST, DB_USER, DB_PASSWORD, LS_DB_NAME);
    if ($mysqliLS->connect_error) {
        if ($mysqliSql->query("CREATE DATABASE ".LS_DB_NAME)) {
            $mysqliLS = new mysqli(DB_HOST, DB_USER, DB_PASSWORD, DB_NAME);
            if ($mysqliLS->connect_error) {
                $error_msg = "Nem lehet kapcsolódni a <b>".DB_NAME."</b> adatbázishoz!<br> MySQL error: " . $mysqliLS->connect_error ;
            } else {
                $installSql = true;
            }
        } else { $error_msg = "Nem lehet létrehozni a <b>".DB_NAME."</b> adatbázist!<br> MySQL error: " . $mysqliLS->connect_error ; }
    }
}




// ---------- Ha hiba van ---------
if ($error_msg) {
    die("HIBA!!!<br>".$error_msg);
}

// --------- Ha már létezik a rendszer az eszközön -------------
else if (! $installFiles && ! $installSql) {

    // --------- Ha van Internet ==> UPDATE csomag telepítése -----------
    if ($isInternet) {
        $zipServerAjaxUrl = _SERVER_URL.'/index.php?mod=sw_project&op=ajax_client&gepszam='._GEPSZAM.'&cmd=get_system_update_file' ;
        if ($zipFileServerURL = url_get_contents($zipServerAjaxUrl)) {

            if ($zipContent = file_get_contents($zipFileServerURL)) {
                $tmplDir = _INSTALL_BASE_DIR . "/" . _SYSTEM_INSTALL_TMPL_DIR;
                $zipFile = $tmplDir . "/" . _SYSTEM_UPDATE_ZIP_FILENAME;
                file_put_contents($zipFile, $zipContent);

                // ---------- UPDATE ZIP fájl kitömörítése ---------------
                $zipFile = _SYSTEM_INSTALL_TMPL_DIR . "/" . _SYSTEM_UPDATE_ZIP_FILENAME;
                $zip = new ZipArchive;
                if ($zip->open($zipFile) === TRUE) {
                    $zipExtDir = _INSTALL_BASE_DIR;
                    if (! $zip->extractTo($zipExtDir)) {
                        echo "Az " . $zipFile . " hibás lehet, mert nem sikerült kicsomagolni.";
                        return false;
                    }
                    $zip->close();
                } else {
                    echo "<h1>ERROR!!!</h1>";
                    echo "<p>A " . $zipFile . " update file nem található az eszközön.</p>";
                    exit();
                }
            }
        }
    }

    header("Location: index.php");
    exit();
}



// ---------------- SYSTEM installation -----------------------

// ------- Ha nincs internet, nem lehet telepíteni --------------
if (! $isInternet) {
    echo "<h1>FATAL ERROR!!!</h1>";
    echo "<h4>A SysWeb kutatási rendszer nincs telepítve ezen az eszközön, és mivel az eszköz jelenleg nincs csatlakoztatva az internetre, a rendszert nem lehet telepíteni.</h4>";
    echo "<p>Kérjük csatlakozzon az eszközzel az internetre (aktív wifi kapcsolat szükséges), és ismételje meg újra a belépést! </p>";
    exit();
}

// --------------------- Rendszer installálás ------------------------
else {

    // --------------------- FÁJLOK TELEPíTÉSE --------------------------------
    if ($installFiles) {
        echo "<h1>INSTALL FILES</h1>";
        // ---------- Telepítő ZIP fájl letöltése ---------------
        if ($zipFileServerURL = _SYSTEM_INSTALL_SERVER_DIR ."/". _SYSTEM_INSTALL_ZIP_FILENAME) {
            if ($zipContent = url_get_contents($zipFileServerURL)) {
                $tmplDir = _INSTALL_BASE_DIR . "/" . _SYSTEM_INSTALL_TMPL_DIR;
                $zipFile .= $tmplDir . "/" . _SYSTEM_INSTALL_ZIP_FILENAME;
                file_put_contents($zipFile, $zipContent);
            } else {
                echo "Source error: " . $zipFileServerURL;
                exit();
            }
        } else {
            echo "<h1>FATAL ERROR!!!</h1>";
            echo "<h4>A SysWeb kutatási rendszert nem lehet telepíteni, mert a " . _SYSTEM_INSTALL_SERVER_DIR . _SYSTEM_INSTALL_ZIP_FILENAME . " fájl nem található a szerveren.</h4>";
            echo "<p>Kérjük vegye fel a kapcsolatot a műszaki adminisztrátorral!</p>";
            exit();
        };

        // ---------- Telepítő ZIP fájl kitömörítése ---------------
        $zipFile = _SYSTEM_INSTALL_TMPL_DIR . "/" . _SYSTEM_INSTALL_ZIP_FILENAME;
        $zip = new ZipArchive;
        if ($zip->open($zipFile) === TRUE) {
            $zipExtDir = _INSTALL_BASE_DIR;
            if (! $zip->extractTo($zipExtDir)) {
                echo "Az " . $zipFile . " hibás lehet, mert nem sikerült kicsomagolni.";
                return false;
            }
            $zip->close();
        } else {
            echo "<h1>ERROR!!!</h1>";
            echo "<p>A " . $zipFile . "nem található az eszközön.</p>";
            exit();
        }
    }

    // --------------------- SQL TELEPíTÉSE --------------------------------
    if ($installSql) {
        echo "<h1>INSTALL SQL</h1>";
        // ---------- Telepítő SQL fájl letöltése ---------------
        if ($sqlFileServerURL = _SYSTEM_INSTALL_SERVER_DIR . _SYSTEM_INSTALL_SQL_FILENAME) {
            if ($sqlContent = url_get_contents($sqlFileServerURL)) {
                $tmplDir = _INSTALL_BASE_DIR . "/" . _SYSTEM_INSTALL_TMPL_DIR;
                $sqlFile .= $tmplDir . "/" . _SYSTEM_INSTALL_SQL_FILENAME;
                file_put_contents($sqlFile, $sqlContent);
            } else {
                echo "Source error: " . $sqlFileServerURL;
                exit();
            }
        } else {
            echo "<h1>FATAL ERROR!!!</h1>";
            echo "<h4>A SysWeb kutatási rendszert nem lehet telepíteni, mert a " . _SYSTEM_INSTALL_SERVER_DIR . _SYSTEM_INSTALL_SQL_FILENAME . " fájl nem található a szerveren.</h4>";
            echo "<p>Kérjük vegye fel a kapcsolatot a műszaki adminisztrátorral!</p>";
            exit();
        };

        // ---------- Telepítő SQL fájl importja ---------------
        $sqlFile = _SYSTEM_INSTALL_TMPL_DIR . "/" . _SYSTEM_INSTALL_SQL_FILENAME;

        $templine = '';
        $l = 0;
        $lines = file($sqlFile);
        foreach ($lines as $line) {
            $l++;
            if (substr($line, 0, 2) == '--' || $line == '')  continue;
            $templine .= $line;
            if (substr(trim($line), -1, 1) == ';') {
                if (! $mysqli->query($templine) ) { echo $sqlFile." || Error performing query in line ".$l.": ".$templine." ERROR:".$mysqli->error; die();  };
                $templine = '';
            }
        }
    }

    header("Location: start.php");
    exit();
}





function url_get_contents($url, $useragent='cURL', $headers=false, $follow_redirects=true, $debug=false) {
    $ch = curl_init();
    curl_setopt($ch, CURLOPT_URL,$url);
    curl_setopt($ch, CURLOPT_RETURNTRANSFER,1);
    curl_setopt($ch, CURLOPT_USERAGENT, $useragent);
    curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
    if ($headers==true){ curl_setopt($ch, CURLOPT_HEADER,1); }
    if ($headers=='headers only') { curl_setopt($ch, CURLOPT_NOBODY ,1); }
    if ($follow_redirects==true) { curl_setopt($ch, CURLOPT_FOLLOWLOCATION, 1); }
    if ($debug==true) {
        $result['contents']=curl_exec($ch);
        $result['info']=curl_getinfo($ch);
    }
    else $result=curl_exec($ch);
    curl_close($ch);
    return $result;
}


// ####################### AJAX kommunikációs példa a szerverrel #######################
//    define('_SERVER_AJAX_URL', _SERVER_URL.'/index.php?mod=sw_project&op=ajax_client');
//    $ServerAjaxUrl = _SERVER_AJAX_URL ."&gepszam="._GEPSZAM."&cmd=get_install_url";
//    $instalDir = file_get_contents($ServerAjaxUrl);

?>